VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "  "
   ClientHeight    =   2385
   ClientLeft      =   30
   ClientTop       =   420
   ClientWidth     =   4710
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2385
   ScaleWidth      =   4710
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cmbAlgorithm 
      Height          =   288
      Left            =   2040
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   1320
      Width           =   2412
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   ""
      Height          =   372
      Left            =   2400
      TabIndex        =   9
      Top             =   1800
      Width           =   1452
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   ""
      Default         =   -1  'True
      Height          =   372
      Left            =   480
      TabIndex        =   8
      Top             =   1800
      Width           =   1572
   End
   Begin VB.ComboBox cmbSize 
      Height          =   288
      Left            =   2040
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   960
      Width           =   2412
   End
   Begin VB.ComboBox cmbProblemType 
      Height          =   288
      Left            =   2040
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   600
      Width           =   2412
   End
   Begin VB.ComboBox cmbFigure 
      Height          =   288
      Left            =   2040
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   240
      Width           =   2412
   End
   Begin VB.Label lblAlgorithm 
      AutoSize        =   -1  'True
      Caption         =   ":"
      Height          =   192
      Left            =   240
      TabIndex        =   6
      Top             =   1320
      Width           =   876
   End
   Begin VB.Label lblSize 
      AutoSize        =   -1  'True
      Caption         =   " :"
      Height          =   192
      Left            =   240
      TabIndex        =   4
      Top             =   960
      Width           =   1176
   End
   Begin VB.Label lblProblemType 
      AutoSize        =   -1  'True
      Caption         =   ":"
      Height          =   192
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   1080
   End
   Begin VB.Label lblFigure 
      AutoSize        =   -1  'True
      Caption         =   ":"
      Height          =   192
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   672
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShowWindow Lib "User32" (ByVal Hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SetForegroundWindow Lib "User32" (ByVal Hwnd As Long) As Long
Private WithEvents Solver As NpAppIntLink
Attribute Solver.VB_VarHelpID = -1
Private Breaked As Boolean
Private SolFound As Boolean

Private Sub cmdClose_Click()
  Unload Me
End Sub

Private Sub cmdRun_Click()
  Dim s As String
  Dim State As NpRunState
  Dim Params As New Collection
  If Not Solver Is Nothing Then
    If Breaked Then
      Solver.DoHalt
    Else
      Solver.DoBreak
    End If
    Breaked = True
    Exit Sub
  End If
  cmdRun.Caption = ""
  cmdClose.Enabled = False
  cmbFigure.Enabled = False
  cmbSize.Enabled = False
  cmbProblemType.Enabled = False
  cmbAlgorithm.Enabled = False
  Set Solver = New NpAppIntLink
  If Not Solver.InitSolver(Nothing, "") Then
    MsgBox "   "
    GoTo Final
  End If
  If Not Solver.LoadScheme(App.Path & "\Chess.npe") Then GoTo Final
  Select Case cmbAlgorithm.Text
    Case "lp_solve": s = "NpLp.NpLpSolver"
    Case "coin cbc": s = "NpCbc.NpCbcSolver"
    Case " ": s = "NpDec.NpDecSolver"
    Case "  "
      s = "NpSeq.NpSeqSolver"
      Params.Add False, "UseLin"
      Params.Add True, "UseLag"
    Case Else: s = ""
  End Select
  If s <> "" Then
    Solver.SetAlgorithm Nothing, s, Params
  End If
  Solver.SeekClass "Main"
  s = cmbFigure.ItemData(cmbFigure.ListIndex) & vbTab
  s = s & cmbProblemType.ItemData(cmbProblemType.ListIndex) & vbTab
  s = s & cmbSize.ItemData(cmbSize.ListIndex) & vbTab
  If Not Solver.SetMembersOrder("Figure" & vbTab & "ProblemType" & vbTab & "N" & vbTab) Then GoTo Final
  If Not Solver.InsertRecord(1, s) Then GoTo Final
  frmView.Show , Me
  frmView.Init cmbSize.ItemData(cmbSize.ListIndex)
  frmView.Caption = "..."
  If Not Solver.Generate Then
    frmView.Caption = " "
    GoTo Final
  End If
  frmView.Caption = "  ..."
  Do
    If Not Solver.Run(State) Then GoTo Final
    If State <> nps_SolutionFound Then Exit Do
  Loop While Not Breaked
  frmView.Caption = frmView.Caption & ": " & IIf(Breaked, "  ", "  ")
Final:
  Set Solver = Nothing
  cmdRun.Caption = ""
  cmdClose.Enabled = True
  cmbFigure.Enabled = True
  cmbSize.Enabled = True
  cmbProblemType.Enabled = True
  cmbAlgorithm.Enabled = True
  Breaked = False
  SolFound = False
  ShowWindow Hwnd, 1
  SetForegroundWindow Hwnd
End Sub

Private Sub Form_Load()
  Dim i As Long
  cmbFigure.AddItem ""
  cmbFigure.ItemData(cmbFigure.ListCount - 1) = 1
  cmbFigure.AddItem ""
  cmbFigure.ItemData(cmbFigure.ListCount - 1) = 2
  cmbFigure.ListIndex = cmbFigure.ListCount - 1
  cmbFigure.AddItem ""
  cmbFigure.ItemData(cmbFigure.ListCount - 1) = 3
  cmbFigure.AddItem ""
  cmbFigure.ItemData(cmbFigure.ListCount - 1) = 4
  cmbFigure.AddItem ""
  cmbFigure.ItemData(cmbFigure.ListCount - 1) = 5
  
  cmbProblemType.AddItem ""
  cmbProblemType.ItemData(cmbProblemType.ListCount - 1) = -1
  cmbProblemType.AddItem ""
  cmbProblemType.ItemData(cmbProblemType.ListCount - 1) = 1
  cmbProblemType.ListIndex = cmbProblemType.ListCount - 1
  
  For i = 1 To 100
    cmbSize.AddItem i & "x" & i
    cmbSize.ItemData(cmbSize.ListCount - 1) = i
    If i = 8 Then
      cmbSize.ListIndex = cmbSize.ListCount - 1
    End If
  Next
  
  cmbAlgorithm.AddItem ""
  cmbAlgorithm.AddItem "  "
  cmbAlgorithm.AddItem " "
  cmbAlgorithm.AddItem "lp_solve"
  cmbAlgorithm.AddItem "coin cbc"
  cmbAlgorithm.ListIndex = cmbAlgorithm.ListCount - 1
End Sub

Private Sub Solver_OnSaveResult()
  Dim i As Long
  Dim Key As Double
  Dim s As String
  
  frmView.Init cmbSize.ItemData(cmbSize.ListIndex)
  If Not Solver.SeekClass("Check") Then Exit Sub
  If Not Solver.SetMembersOrder("x" & vbTab & "y" & vbTab & "Busy" & vbTab) Then Exit Sub
  If Solver.GetRecordFirst(Key) Then
    Do
      Solver.ReadRecord Key, s, 3
      If Right(s, 2) = "1" & vbTab Then
        i = InStr(1, s, vbTab)
        frmView.Check Left(s, i - 1), Mid(s, i + 1, InStr(i + 1, s, vbTab) - i)
      End If
    Loop While Solver.GetRecordNext(Key)
  End If
  Solver_OnUpdateView
End Sub

Private Sub Solver_OnSolutionFound()
  SolFound = True
End Sub

Private Sub Solver_OnUpdateView()
  If SolFound Then
    frmView.Caption = cmbFigure.Text & ": " & cmbProblemType.Text & ": " & cmbSize.Text & ":  " & Abs(Solver.MinimumRecord) & "  " & Abs(Solver.MinimumInf)
  End If
End Sub
